function cache = initializeOptimizerCache(solver,W)
    switch lower(solver)
        case {"sgdm", "rmsprop", "adagrad"}
            cache = zeros(size(W)); % v
        case "adam"
            cache = {zeros(size(W)),zeros(size(W))}; % v, m 
        otherwise
            cache = []; % nothing
    end
end